SQLFunctionTemplate (Hibernate JavaDocs)
Date: 2012-04-05

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.hibernate.dialect.function
Class SQLFunctionTemplate

    java.lang.Object
      org.hibernate.dialect.function.SQLFunctionTemplate

All Implemented Interfaces:
  SQLFunction

    public class SQLFunctionTemplate

extends Object
implements SQLFunction

Represents HQL functions that can have different representations in different SQL dialects. E.g. in HQL we can define function `concat(?1, ?2)` to concatenate two strings p1 and p2. Target SQL function will be dialect-specific, e.g. `(?1 || ?2)` for Oracle, `concat(?1, ?2)` for MySql, `(?1 + ?2)` for MS SQL. Each dialect will define a template as a string (exactly like above) marking function parameters with '?' followed by parameter's index (first index is 1).

Constructor Summary
`SQLFunctionTemplate(Type type, String template)`
`SQLFunctionTemplate(Type type, String template, boolean hasParenthesesIfNoArgs)`

Method Summary
`Type` | `getReturnType(Type argumentType, Mapping mapping)` The return type of the function.
`boolean` | `hasArguments()` Does this function have any arguments?
`boolean` | `hasParenthesesIfNoArguments()` If there are no arguments, are parentheses required?
`String` | `render(Type argumentType, List args, SessionFactoryImplementor factory)` Render the function call as SQL fragment.
`String` | `toString()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SQLFunctionTemplate

    public SQLFunctionTemplate(Type type,
                               String template)

### SQLFunctionTemplate

    public SQLFunctionTemplate(Type type,
                               String template,
                               boolean hasParenthesesIfNoArgs)

Method Detail

### render

    public String render(Type argumentType,
                         List args,
                         SessionFactoryImplementor factory)

  Render the function call as SQL fragment.

  Note, the 'firstArgumentType' parameter should match the one passed into `SQLFunction.getReturnType(org.hibernate.type.Type, org.hibernate.engine.spi.Mapping)`

  Specified by:
    `render` in interface `SQLFunction`
  Parameters:
    `argumentType` - The type of the first argument
    `args` - The function arguments
    `factory` - The SessionFactory
  Returns:
    The rendered function call

### getReturnType

    public Type getReturnType(Type argumentType,
                              Mapping mapping)
                       throws QueryException

  The return type of the function. May be either a concrete type which is preset, or variable depending upon the type of the first function argument.

  Note, the 'firstArgumentType' parameter should match the one passed into `SQLFunction.render(org.hibernate.type.Type, java.util.List, org.hibernate.engine.spi.SessionFactoryImplementor)`

  Specified by:
    `getReturnType` in interface `SQLFunction`
  Parameters:
    `argumentType` - The type of the first argument
    `mapping` - The mapping source.
  Returns:
    The type to be expected as a return.
  Throws:
    `QueryException` - Indicates an issue resolving the return type.

### hasArguments

    public boolean hasArguments()

  Does this function have any arguments?

  Specified by:
    `hasArguments` in interface `SQLFunction`
  Returns:
    True if the function expects to have parameters; false otherwise.

### hasParenthesesIfNoArguments

    public boolean hasParenthesesIfNoArguments()

  If there are no arguments, are parentheses required?

  Specified by:
    `hasParenthesesIfNoArguments` in interface `SQLFunction`
  Returns:
    True if a no-arg call of this function requires parentheses.

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2012 Red Hat, Inc. All Rights Reserved.